#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <array>
#include <list>

struct node{
    node(int targetCity, int price):targetCity(targetCity),price(price){}
    int targetCity;
    int price;
};
struct inputNode {
    inputNode(int cityNumber, int numOfCranes, int idOfCrane, int price) {
        this->numOfCranes = numOfCranes;
        this->idOfCrane = idOfCrane;
        this->price = price;
    }
    int cityNumber;
    int numOfCranes;
    int idOfCrane;
    int price;
};

int main() {
    int numOfCities;
    std::cin >> numOfCities;
    std::vector<inputNode> input;
    std::multimap<int,node> path;//startCity -> node
//INPUT
    for (int cityID = 0; cityID < numOfCities; ++cityID) {
            int numOfCranes;
            std::cin>>numOfCranes;
            int idOfCrane, priceInTheCity;
            std::cin>>idOfCrane >> priceInTheCity;
            input.emplace_back(inputNode(cityID,numOfCranes, idOfCrane, priceInTheCity));//tohle bude sedet na pozici []
        }
// PLNENI MAPY
    for (int first = 0; first < numOfCities; ++first) {
        if(input[first].numOfCranes <= 0)
            continue;//nemohu to tam koupit
        for (int second = first + 1; second < numOfCities; ++second) {
            int tmpPrice = input[second].price - input[first].price;
            if(tmpPrice <= 0 || input[first].idOfCrane != input[second].idOfCrane)
                continue;
            path.emplace(first,node(second, tmpPrice));
        }
    }
//BFS
    std::map<int,int> bfsResult;//mesto, vydelek
    std::queue<int> bfsqueue;
    for(auto i : path)
        bfsqueue.emplace(i.first);//pridam vsechny body, ke se vyplati neco vyzvednout

    while(!bfsqueue.empty()){
        int city = bfsqueue.front();//mesto ve kterym ted jsem
        bfsqueue.pop();
        //pridat vsechny mesta na dosah do fronty, zaroven k nim ulozit do mapy hodnoty
        int price = 0;
        auto res = bfsResult.find(city);
        if(res != bfsResult.end()){
            price = res->second;//nejvetsi vydelek, kterym jsem se do tohoto mesta dostal
        }
        //projit vsechny mesta na dosah
        for (auto i = path.find(city); i != path.end() && i->first == city ; ++i) {//mesta kam pujdu
            int targetCity = i->second.targetCity;
            bfsqueue.push(targetCity);//podivam se tam v pristim bfs
            auto inBfsRes = bfsResult.find(targetCity);
            if(inBfsRes == bfsResult.end()){//pokud jsem tam jeste nebyl pridat to
                bfsResult.emplace(targetCity, (price + i->second.price));
            }else{
                if(price + i->second.price > inBfsRes->second)
                    inBfsRes->second = price + i->second.price;
            }
        }
    }
    //find max
    int max = 0;
    for(auto i : bfsResult)
        if(i.second > max)
            max = i.second;
    std::cout << max;
    return 0;
}
